



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MySQL之外键约束</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MySQL之外键约束</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 05:46:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1><strong><a href="http://www.cnblogs.com/yidianfeng/archive/2011/02/24/1964148.html" rel="external nofollow noreferrer">MySQL之外键约束</a></strong></h1>
<div>
<p>MySQL有两种常用的引擎类型：MyISAM和InnoDB。目前只有InnoDB引擎类型支持外键约束。InnoDB中外键约束定义的语法如下：</p>
<p>[CONSTRAINT [symbol]] FOREIGN KEY<br />&nbsp;&nbsp;&nbsp; [index_name] (index_col_name, ...)<br />&nbsp;&nbsp;&nbsp; REFERENCES tbl_name (index_col_name,...)<br />&nbsp;&nbsp;&nbsp; [ON DELETE reference_option]<br />&nbsp;&nbsp;&nbsp; [ON UPDATE reference_option]</p>
<p>reference_option:<br />&nbsp;&nbsp;&nbsp; RESTRICT | CASCADE | SET NULL | NO ACTION&nbsp; 外键的使用需要满足下列的条件：</p>
<p>1. 两张表必须都是InnoDB表，并且它们没有临时表。</p>
<p>2. 建立外键关系的对应列必须具有相似的InnoDB内部数据类型。</p>
<p>3. 建立外键关系的对应列必须建立了索引。</p>
<p>4. 假如显式的给出了CONSTRAINT symbol，那symbol在数据库中必须是唯一的。假如没有显式的给出，InnoDB会自动的创建。</p>
<p>如果子表试图创建一个在父表中不存在的外键值，InnoDB会拒绝任何INSERT或UPDATE操作。如果父表试图UPDATE或者DELETE任何子表中存在或匹配的外键值，最终动作取决于外键约束定义中的ON UPDATE和ON DELETE选项。InnoDB支持5种不同的动作，如果没有指定ON DELETE或者ON UPDATE，默认的动作为RESTRICT:</p>
<p>1. CASCADE: 从父表中删除或更新对应的行，同时自动的删除或更新自表中匹配的行。ON DELETE CANSCADE和ON UPDATE CANSCADE都被InnoDB所支持。</p>
<p>2. SET NULL: 从父表中删除或更新对应的行，同时将子表中的外键列设为空。注意，这些在外键列没有被设为NOT NULL时才有效。ON DELETE SET NULL和ON UPDATE SET SET NULL都被InnoDB所支持。</p>
<p>3. NO ACTION: InnoDB拒绝删除或者更新父表。</p>
<p>4. RESTRICT: 拒绝删除或者更新父表。指定RESTRICT（或者NO ACTION）和忽略ON DELETE或者ON UPDATE选项的效果是一样的。</p>
<p>5. SET DEFAULT: InnoDB目前不支持。</p>
<p>外键约束使用最多的两种情况无外乎：</p>
<p>1）父表更新时子表也更新，父表删除时如果子表有匹配的项，删除失败；</p>
<p>2）父表更新时子表也更新，父表删除时子表匹配的项也删除。</p>
<p>前一种情况，在外键定义中，我们使用ON UPDATE CASCADE ON DELETE RESTRICT；后一种情况，可以使用ON UPDATE CASCADE ON DELETE CASCADE。</p>
<p>InnoDB允许你使用ALTER TABLE在一个已经存在的表上增加一个新的外键:</p>
<p>ALTER TABLE tbl_name<br />&nbsp;&nbsp;&nbsp; ADD [CONSTRAINT [symbol]] FOREIGN KEY<br />&nbsp;&nbsp;&nbsp; [index_name] (index_col_name, ...)<br />&nbsp;&nbsp;&nbsp; REFERENCES tbl_name (index_col_name,...)<br />&nbsp;&nbsp;&nbsp; [ON DELETE reference_option]<br />&nbsp;&nbsp;&nbsp; [ON UPDATE reference_option]</p>
<p>InnoDB也支持使用ALTER TABLE来删除外键：<br />ALTER TABLE tbl_name DROP FOREIGN KEY fk_symbol;</p>
<p>本文来自CSDN博客，转载请标明出处：<a href="http://blog.csdn.net/cnjsnt_s/archive/2010/05/01/5548280.aspx" rel="external nofollow noreferrer">http://blog.csdn.net/cnjsnt_s/archive/2010/05/01/5548280.aspx</a></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8okro59.html">div的水平和垂直居中</a>
		</li>
						<li><a href="https://www.batexi.com/a/390k443q.html">C语言学习015&colon;联合&lpar;union&rpar;与枚举&lpar;enum&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/39015j48.html">ajax跨域之设置Access-Control-Allow-Origin</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydwkm2q.html">PHP脚本memcache类的源码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmlw719.html">BIP&lowbar;开发案例06&lowbar;以RB&period;RDF为数据源BIP&period;RTF为模板的简单例子（案例）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mep1eq.html">jsp或Action获取请求参数中文乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd4zldq.html">SAE J2534 Pass-Thru API</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xkg3r9.html">&lbrack;CODEVS1295&rsqb;N皇后（位运算&plus;搜索）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm3l2e9.html">JS论坛地址备忘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1vrn1q.html">&lbrack;置顶&rsqb; cocos2d-x 3&period;0游戏开发xcode5帅印博客教学 004&period;&lbrack;HoldTail&rsqb;主角的上下飞行跟移动</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpvyx59.html">PHP获取远程文件的几种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpk6gr9.html">Hibernate注解配置与XML配置区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k14d29.html">django&period;db&period;utils&period;OperationalError&colon; cannot ALTER TABLE &amp;quot&semi;servers&lowbar;ecs&amp;quot&semi; because it has pending trigger events</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyovxx9.html">react 和 seamless-immutable</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdd5ez9.html">深入分析&period;NET应用程序SQL注入【危害】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyx7g19.html">Jquery 组 标签页</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r353m9.html">poj-2888-矩阵&plus;polya</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4zm5m9.html">windows下vscode修复c&plus;&plus;找不到头文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9606jr39.html">&lbrack;Leetcode&rsqb;下一个更大元素II</a>
		</li>
						<li><a href="https://www.batexi.com/a/963m0w39.html">【GIS】postgres（postgis） --》nodejs&plus;express --》geojson --》leaflet</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gmlppe9.html">Activity（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1wom39.html">RHEL5&period;8安装Oracle11g</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmyoe09.html">ASPNET程序中常用的三十三种代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmyo019.html">asp&period;net 导出excel文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjz31d9.html">Spring随笔 - 事务隔离级别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m4d3gq.html">querySelectorAll 方法相比 getElementsBy 系列方法有什么区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvxjjxq.html">解决pycharm无法导入本地包的问题（Unresolved reference &amp;&num;39&semi;tutorial&amp;&num;39&semi;）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok73259.html">aspose&period;words 处理word转PDF</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m42kjq.html">CSS自学笔记（12）&colon;CSS3文字特效</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wrgoxq.html">C语言中内存分配 &lpar;转&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
